"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AnimatedNumber = void 0;

var _react = _interopRequireDefault(require("react"));

var _jsxRuntime = require("react/jsx-runtime");

const AnimatedNumber = ({
  duration = 1000,
  value,
  formatValue = v => `${v}`
}) => {
  const [animatedValue, setAnimatedValue] = _react.default.useState(0);

  const [animateOpt, setAnimateOpt] = _react.default.useState({
    duration,
    toValue: 0
  });

  _react.default.useEffect(() => {
    setAnimateOpt({
      duration,
      toValue: value
    });
  }, [duration, value]);

  _react.default.useEffect(() => {
    let tick = -1;
    const startTime = +new Date();
    const endTime = new Date().valueOf() + duration;
    const startValue = animatedValue;
    const endValue = animateOpt.toValue;

    const runAnimation = () => {
      const t = +new Date();

      if (t >= endTime) {
        setAnimatedValue(endValue);
        return;
      }

      setAnimatedValue(startValue + (endValue - startValue) * ((endTime - t) / (endTime - startTime)));
      tick = requestAnimationFrame(runAnimation);
    };

    runAnimation();
    return () => cancelAnimationFrame(tick);
  }, [animateOpt]); // eslint-disable-line react-hooks/exhaustive-deps


  return /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
    children: formatValue(animatedValue)
  });
};

exports.AnimatedNumber = AnimatedNumber;